#include <bits/stdc++.h>
#define ll long long
using namespace std;
const int N = 500 + 10;
int n, P;
int dp[N][N][N];
void Add(int &x, int y) {if((x += y) >= P && (x -= P)); }
int main() {
    freopen("tree.in", "r", stdin);
    freopen("tree.out", "w", stdout);
    scanf("%d%d", &n, &P);
    for(int i = 1; i <= n - 1; i++) dp[1][1][i] = i % P;
    for(int i = 1; i < n - 1; i++) {
        for(int j = 1; j <= n; j++) {
            for(int k = 1; k <= n; k++) {
                if(!dp[i][j][k]) continue;
                int v = (ll)dp[i][j][k] * j * k % P;
                Add(dp[i + 1][j + 1][k], v);
                Add(dp[i + 1][j][k - 1], (ll)dp[i][j][k] * j * (k - 1) % P);
                v = v * 2;
                if(v >= P) v -= P;
                v = -v;
                if(v < 0) v += P;
                Add(dp[i + 1][j][k], v);
            }
        }
    }
    for(int i = 2; i <= n; i++) {
        int sum = 0;
        for(int j = 1; j <= n; j++) Add(sum, (ll)dp[i - 1][j][1] * j % P);
        printf("%d\n", sum);
    }
    return 0;
}